<template>
  <div>
    <RimowSelectize
      v-if="parentValue"
      placeholder="Select a field..."
      data-cy="dataset-file-field-dropdown"
      :add-properties="addProperties(parameter, HTMLSelectElement)"
      item-icon="columns"
      :options="fileFields"
      :selected="selected"
      :disabled="disabled"
      @change="updateDatasetFileColumnField"
    />
    <span v-else class="sce-param-value text-muted">No file selected</span>
  </div>
</template>

<script>
export default {
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    addProperties: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {
      projectId: this.$nuxt.$route.params.id,
      scenarioId: this.$nuxt.$route.params.scenarioId,
      HTMLSelectElement: null,
    };
  },
  computed: {
    param() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.parameter.key
      ];
    },
    parentParam() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.param.fileSelectKey
      ];
    },
    parentDatasetId() {
      if (this.parentParam) {
        const datasetParameter =
          this.$nuxt.context.store.state.parameters.inputMap[
            this.parentParam.datasetSelectKey
          ];
        return datasetParameter?.value;
      }
      return undefined;
    },
    parentValue() {
      return this.parentParam?.value;
    },
    fileFields() {
      if (this.parentValue && this.parentDatasetId) {
        return this.$nuxt.context.store.getters['datasets/datasetFileFields'](
          this.parentDatasetId,
          this.parentValue
        );
      }
      return [];
    },
    selected() {
      if (this.parentValue && this.parentDatasetId && this.param.value) {
        return this.fileFields.find((field) => {
          return field === this.param.value;
        });
      }
      return undefined;
    },
  },
  async mounted() {
    this.HTMLSelectElement = HTMLSelectElement;
    if (this.parentValue && this.parentDatasetId) {
      await this.$nuxt.context.store.dispatch('datasets/fetchFileMetadata', {
        datasetId: this.parentDatasetId,
        fileId: this.parentValue,
      });
    }
  },
  methods: {
    async updateDatasetFileColumnField(value) {
      if (this.disabled) return;
      await this.$nuxt.context.store.dispatch(
        'parameters/updateDatasetFileFieldSelect',
        {
          projectId: this.projectId,
          scenarioId: this.scenarioId,
          key: this.parameter.key,
          newSelected: value,
        }
      );
    },
  },
};
</script>
